## blockdiff 0.1.0~git20211220.cc329c8

=== Makefile ===

#   blockdiff - block based binary patch tool
#
#   Copyright (C) 2017 Stefan Lengfeld <stefan@lengfeld.xyz>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 2 of the License, or
#   (at your option) version 3 of the License. See also README.md.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.


prefix = $(HOME)
mandir ?= $(prefix)/share/man
man1dir = $(mandir)/man1
DESTDIR ?=


TARGETS = blockdiff blockdiff.html blockdiff.1 README.html

all: $(TARGETS)               ### Generate documentation and program

blockdiff: src/blockdiff.py
	cp $< $@

%.html: %.md
	pandoc -f markdown -t html -s --toc $< -o $@

%.1: %.md
	pandoc -f markdown -t man -s $< -o $@


.PHONY: tests
tests: blockdiff              ### Runs the python unit tests
	python3 -m unittest discover -s tests


# Ignore
#   E501 line too long (83 > 79 characters)
.PHONY: check
check:                        ### Runs the pep8 source code checker
	@pep8 --ignore E501 blockdiff tests/*.py || true


.PHONY: install
install: blockdiff            ### Installs program to $(prefix)/
	install -Dm 755 blockdiff $(DESTDIR)/$(prefix)/bin/blockdiff

.PHONY:
install-doc: blockdiff.1
	install -Dm 644 blockdiff.1 $(DESTDIR)/$(man1dir)/blockdiff.1


.PHONY: clean
clean:
	rm -rf $(TARGETS)
	find tests -maxdepth 1 -name "Test*" -exec rm "-rf" "{}" ";"


# See http://marmelab.com/blog/2016/02/29/auto-documented-makefile.html
.PHONY: help
help: ## Show the help prompt
	  @grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

=== assumptions/Makefile ===

#   blockdiff - block based binary patch tool
#
#   Copyright (C) 2017 Stefan Lengfeld <stefan@lengfeld.xyz>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 2 of the License, or
#   (at your option) version 3 of the License. See also README.md.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Use bash for 'set -o pipefail'
SHELL = bash

TARGETS = files image.ext4 image.btrfs report.ext4.txt report.btrfs.txt files.tar report.tar.txt

# Filesystem blocksize. Valid values for ext4 and btrfs are 1024, 2048 or 4096.
BLOCKSIZE = 2048


all: $(TARGETS)


files:
	./gen-files.py $(BLOCKSIZE) $@


image.ext4: files
	dd if=/dev/zero of=$@ count=100 bs=1M conv=sparse
	mkfs.ext4 -b $(BLOCKSIZE) $@
	mkdir -p mnt-ext4
	sudo mount  $@ mnt-ext4
	sudo cp -rv $</* mnt-ext4/
	sudo umount mnt-ext4
	rmdir mnt-ext4

image.btrfs: files
	dd if=/dev/zero of=$@ count=100 bs=1M conv=sparse
	mkfs.btrfs -s  $(BLOCKSIZE) $@
	mkdir -p mnt-btrfs
	sudo mount  $@ mnt-btrfs
	sudo cp -rv $</* mnt-btrfs/
	sudo umount mnt-btrfs
	rmdir mnt-btrfs

files.tar: files
	tar -c -f $@ $<

report.ext4.txt: files image.ext4
	set -o pipefail ; ./find-blocks.py $(BLOCKSIZE) $^ | tee $@


# NOTE: btrfs stores files up to 2048 bytes in the directory tree, not in
# separate blocks. For files smaller or equal to 2048 the assumption does not
# hold.
report.btrfs.txt: files image.btrfs
	set -o pipefail ; ./find-blocks.py $(BLOCKSIZE) $^ | tee $@


# tar uses always a blocksize of 512 bytes.
report.tar.txt: files files.tar
	set -o pipefail ; ./find-blocks.py 512 $^ | tee $@


.PHONY: clean
clean:
	rm -rf $(TARGETS)

=== debian/changelog ===
blockdiff (0.1.0~git20211220.cc329c8-1) trixie; urgency=medium

  * Initial release

 -- Richard Oliver <richard.oliver@raspberrypi.com>  Fri, 19 Sep 2025 15:17:03 +0100

=== debian/control ===
Source: blockdiff
Section: embedded
Priority: optional
Maintainer: Richard Oliver <richard.oliver@raspberrypi.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 python3-setuptools,
 python3-all,
 pandoc,
Standards-Version: 4.7.2
Homepage: https://stefan.lengfeld.xyz/projects/blockdiff/

Package: blockdiff
Architecture: all
Depends:
 ${python3:Depends},
 ${misc:Depends},
Description: binary patch tool for block based file and disk formats
 blockdiff is a binary patch tool (similar to bsdiff). It operates on large
 blocks of bytes (typically ~4k) rather than individual bytes of data.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

#export PYBUILD_NAME=blockdiff
#export PYBUILD_DISABLE=install
export HOME=usr

%:
	#dh $@ --buildsystem=pybuild
	dh $@
	#@echo "Done"

override_dh_auto_install:
	make HOME=usr DESTDIR=$(CURDIR)/debian/tmp install install-doc

# If you need to rebuild the Sphinx documentation:
# Add sphinxdoc to the dh --with line.
#
# And uncomment the following lines.
#execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
#execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
#execute_after_dh_auto_build-indep:
#	PYTHONPATH=. python3 -m sphinx -N -bhtml \
#	docs/ build/html # HTML generator
#	PYTHONPATH=. python3 -m sphinx -N -bman \
#	docs/ build/man # Manpage generator
